
const canvas = document.getElementById("myCanvas");
const ctx = canvas.getContext("2d");

let n=50;
let x,y,dx,dy,r,m,v;
let i,j,stp,kx,ky,p;
let ang,k;
let d = { width: canvas.width, height: canvas.height };

function init() {
p=0;k=0;i=0;
v=18;
ang=3.1416/n;
r=2;
m=r*r;	 
x=d.width/2;
y=d.height-2*r;
dx=p*v*Math.cos(ang*i+k);
dy=-p*v*Math.sin(ang*i+k);		
buffer = createBuffer(d.width, d.height);
drawToBuffer();
}

function createBuffer(width, height) {
    const offscreenCanvas = document.createElement('canvas');
    offscreenCanvas.width = width;
    offscreenCanvas.height = height;
    return offscreenCanvas;
}

function drawToBuffer() {
    const g = buffer.getContext("2d");
	g.fillStyle = "red";
	g.beginPath();     
    g.arc(d.width/2,d.height-2*r, r, 0, Math.PI * 2);
    g.fill();
	g.strokeStyle = "blue";
    g.beginPath();
    g.moveTo(x,y);
    g.lineTo(x+dx,y+dy);
	g.stroke();
		}
		
function move() {
	
			dy=dy+p;
			x=x+dx;
			y=y+dy;
	
		if (y>d.height-2*r) {
			i=i+1;
			x=d.width/2;
			y=d.height-2*r;
			dx=p*v*Math.cos(ang*i+k);
			dy=-p*v*Math.sin(ang*i+k);
			if(i==n){
				i=0;p=0;
				}
			}		        
}

function start() {
    setInterval(function() {
        move();
        drawToBuffer();
        ctx.clearRect(0, 0, canvas.width, canvas.height);
        ctx.drawImage(buffer, 0, 0);
    }, 30);
}

document.getElementById('Set').addEventListener('click', Set);
document.getElementById('Run').addEventListener('click', Run);


function Set() {
      const g = buffer.getContext("2d");
	  g.fillStyle = "white";
	  g.fillRect(0,0,d.width,d.height);
		    p=0;	 
			x=d.width/2;
			y=d.height-2*r;
			dx=p*v*Math.cos(ang*i+k);
			dy=-p*v*Math.sin(ang*i+k);	
}
function Run() {
      const g = buffer.getContext("2d");
	  g.fillStyle = "white";
	  g.fillRect(0,0,d.width,d.height);
			p=1;
			x=d.width/2;
			y=d.height-2*r;
			dx=p*v*Math.cos(ang*i+k);
			dy=-p*v*Math.sin(ang*i+k);			
}


init();
start();




